## Distributed as part of the supplementary material for the manuscript
## "Jeffreys-prior penalty, finiteness and shrinkage in binomial-response generalized linear models"
##
## Authors: Ioannis Kosmidis, David Firth
## Date: 19 March 2020
## Licence: GPL 2 or greater
## NOT A POLISHED PIECE OF PUBLIC-USE SOFTWARE!  Provided "as is".
## NO WARRANTY OF FITNESS FOR ANY PURPOSE!

#' @param dat a data frame where each row is a competition and the columns
#'     indicate the winner and the loser of the competition
prepare_BT_df <- function(data) {
    n <- nrow(data)
    data <- data[c("winner", "loser")]
    players <- sort(unique(unlist(data)))
    n_players <- length(players)
    X <- matrix(0, n, n_players)
    colnames(X) <- players
    for (j in seq.int(n)) {
        winner <- data[j, "winner"]
        loser <- data[j, "loser"]
        X[j, winner] <- 1
        X[j, loser] <- -1
    }
    y <- rep(1, each = n)
    out <- data.frame(y = y, X)
    class(out) <- c("BT_df", class(out))
    out
}


qvfit <- function(fit) {
    v <- vcov(fit)
    est <- coef(fit)
    ind <- is.na(est)
    v[ind, ] <- 0
    v[, ind] <- 0
    qv <- qvcalc(v)
    est[ind] <- 0
    qv$qvframe[, "estimate"] <- est
    qv
}
